<?php


add_filter('ethereum_wallet_settings_tabs', 'ETHEREUM_WALLET_api_keys_settings_tabs_hook', 30, 1);
function ETHEREUM_WALLET_api_keys_settings_tabs_hook($possible_screens)
{
    $possible_screens['api_keys'] = esc_html(__('API Keys', 'ethereum-wallet'));
    return $possible_screens;
}

add_filter('ethereum_wallet_get_save_options', 'ETHEREUM_WALLET_api_keys_get_save_options_hook', 30, 3);
function ETHEREUM_WALLET_api_keys_get_save_options_hook($new_options, $options, $current_screen)
{
    if ('api_keys' !== $current_screen) {
        return $new_options;
    }

    $new_options['cryptocompare_api_key'] = (!empty($_POST['ETHEREUM_WALLET_cryptocompare_api_key'])     /*&& is_numeric( $_POST['ETHEREUM_WALLET_cryptocompare_api_key'] )*/)     ? sanitize_text_field($_POST['ETHEREUM_WALLET_cryptocompare_api_key'])      : '';

    return $new_options;
}

add_filter('ethereum_wallet_print_options', 'ETHEREUM_WALLET_api_keys_print_options_hook', 30, 2);
function ETHEREUM_WALLET_api_keys_print_options_hook($options, $current_screen)
{
    if ('api_keys' !== $current_screen) {
        return;
    }
?>

    <tr valign="top">
        <th scope="row"><?php _e("Cryptocompare API Key", 'ethereum-wallet'); ?></th>
        <td>
            <fieldset>
                <label>
                    <input class="text" name="ETHEREUM_WALLET_cryptocompare_api_key" type="text" maxlength="70" placeholder="<?php _e("Put your Cryptocompare API Key here", 'ethereum-wallet'); ?>" value="<?php echo !empty($options['cryptocompare_api_key']) ? esc_attr($options['cryptocompare_api_key']) : ''; ?>">
                    <p><?php echo sprintf(
                            __('The API key for the <a target="_blank" href="%s">%s</a>. You need to register on this site to obtain it.', 'ethereum-wallet'),
                            'https://min-api.cryptocompare.com',
                            'https://min-api.cryptocompare.com'
                        ) ?></p>
                    <p><?php echo sprintf(__('Enter it if you plan to display fiat %s rate.', 'ethereum-wallet'), ETHEREUM_WALLET_getCurrencyName()) ?></p>
                </label>
            </fieldset>
        </td>
    </tr>

<?php
}
